/*
 * iFacturasBean.java
 *
 * Created on 20 de septiembre de 2003, 9:41
 */

package ejbfacturas;

/**
 *
 * @author Roberto Canales
 */

import javax.rmi.*;
import javax.ejb.*;
import java.util.*;
import java.net.*;
import javax.naming.*;
import facturascomun.*;


public class iFacturasBean implements SessionBean, iFacturasContrato
{    
    SessionContext miEjbContexto = null;
    
    public void ejbCreate() throws CreateException {
    }
    
    public void ejbActivate() {
    }
    
    public void ejbPassivate() {
    }
    
    public void ejbRemove() {
    }
    
    public void setSessionContext(SessionContext context) {
        depura("Establecemos el contexto");
        miEjbContexto = context;
    }

    /**
     * Retorna el numero de facturas en base de datos
     */  
    public int recuperaNumeroFacturas()
    {
        // Retornamos un valor por defecto  
        return 1;
    }
     
    /** 
    * Recupera las lista de facturas de base de datos
    */
    public Vector recuperaIdFacturas()
    {
        Vector vIdFacturas = new Vector();
        vIdFacturas.addElement(new Integer(0));
        return vIdFacturas;
    }   
    
    /**
     * Recupera una factura concreta
     */
    public Factura recuperaFacturaPorId(int pId)
    {
        return new Factura("0","AdictosAlTrabajo","Desarrollo creativo","54332211s", "Calle Desconocida", "20/10/2203", 1234.12);
    }


    /**
     * Inserta una nueva factura
     */
    public boolean insertaNuevaFactura(Factura pFactura)
    {

        depura("Comenzamos la insercion de elementos CMP nuevo 2");
        
        try 
        {
            Context contexto = new InitialContext(); 
            depura("Hemos creado el contexto y vamos a buscar objeto CMP");
            
            iFacturaItemHomeCMP miHome = null;

            Object objetoGenerico = contexto.lookup("java:comp/env/ejb/entidadfacturacmp");

            depura("La clase original es " + objetoGenerico.getClass().getName());
            miHome = (iFacturaItemHomeCMP) PortableRemoteObject.narrow(objetoGenerico,iFacturaItemHomeCMP.class);
            
            iFacturaItemCMP miFactura = miHome.create( pFactura);
            
            /*depura("Fin de creacin del EJB de entidad");
            
            depura("El id a crear es " + pFactura.getId());
            iFacturaItem miFactura = miHome.create( pFactura);
            depura("Buscamos por ID = 0");
            
            iFacturaItem miFactura = miHome.findByPrimaryKey("22");
            depura("Mostramos el concepto " + miFactura.getSConcepto());
            */    
            
            miFactura = miHome.findByPrimaryKey("22");
            depura("Vemos si se recupera " + miFactura.getId());
            
            depura("La operacion ha finalizado");
        }
        catch(Exception e)
        {
            depura("Error al probar ejb de entidad: " + e.getMessage());
        }
               
        return true;
    }

    private void depura(String cadena)
    {
        System.out.println("EJB iFacturasBean: " + cadena);
    }
 
}